import java.util.*;

import javax.mail.*;
import javax.mail.internet.*;

public class TestJbexJavaMailProvider
{
	public static void main(String[] argv) throws NoSuchProviderException, MessagingException
	{
		// Set here the Exchange server's hostname and login username/password:
		String hostname = "localhost";
		String username = "username";
		String password = "password";
		
		sendMessage(hostname, username, password);
		readInbox(hostname, username, password);
	}

	private static void sendMessage(String hostname, String username, String password) throws NoSuchProviderException, MessagingException
	{
		// Create a session
		Session session = Session.getDefaultInstance(new Properties());

		// Create and connect to the transport
		Transport transport = session.getTransport("jbexTransport");
		transport.connect(hostname, username, password);

		// Recipients
		Address[] recipients = new Address[] {new InternetAddress("test@example.com")};
		
		// Create a message
		Message msg = new MimeMessage(session);
		msg.setRecipients(Message.RecipientType.TO, recipients);
		msg.setSubject("Test message");
		msg.setContent("Hello from JavaMail", "text/plain");
		msg.saveChanges();
		
		// Send the message
		transport.sendMessage(msg, recipients);

		// Disconnect
		transport.close();
	}	

	private static void readInbox(String hostname, String username, String password) throws NoSuchProviderException, MessagingException
	{
		// Create a session
		Session session = Session.getDefaultInstance(new Properties());

		// Create and connect to the store
		Store store = session.getStore("jbexStore");
		store.connect(hostname, username, password);

		// Open the Inbox folder
		Folder inbox = store.getFolder("INBOX");
		inbox.open(Folder.READ_WRITE);

		// List messages
		int count = inbox.getMessageCount();
		System.out.println("Messages count in inbox: " + count);

		for(int i=1; i <= Math.min(count, 10); i++)
		{
			Message message = inbox.getMessage(i);

			String subject = message.getSubject();
			Address[] fromAddresses = message.getFrom();
			Date sentDate = message.getSentDate();

			System.out.println("Message " + i + ": " + subject + ", From: " + fromAddresses[0] + ", Sent: " + sentDate);
		}

		// Disconnect
		inbox.close(true);
		store.close();
	}	
}
