package com.moyosoft.exchange.javamail;

import java.net.*;

import javax.mail.*;

import com.moyosoft.exchange.*;

public class JbexStore extends Store
{
	private Exchange exchange;

	public JbexStore(Session session, URLName urlname)
	{
		super(session, urlname);
	}

	protected boolean protocolConnect(String host, int port, String user, String password) throws MessagingException
	{
		try
		{
			exchange = new Exchange(host, user, password);
		}
		catch(ExchangeServiceException e)
		{
			handleError(e);
		}

		return true;
	}

	public Folder getDefaultFolder() throws MessagingException
	{
		try
		{
			return new JbexFolder(this, exchange.getTopFolder());
		}
		catch(ExchangeServiceException e)
		{
			handleError(e);
		}
		
		return new JbexFolder(this, null);
	}

	public Folder getFolder(String name) throws MessagingException
	{
		try
		{
			if("INBOX".equals(name))
			{
				return new JbexFolder(this, exchange.getInboxFolder());
			}
			else
			{
				return new JbexFolder(this, exchange.getTopFolder(name));
			}
		}
		catch(ExchangeServiceException e)
		{
			handleError(e);
		}
		
		return new JbexFolder(this, null);
	}

	public Folder getFolder(URLName urlName) throws MessagingException
	{
		try
		{
			return getFolder(urlName.getURL().getPath());
		}
		catch(MalformedURLException ex)
		{
			throw new MessagingException(ex.getMessage(), ex);
		}
	}

	private void handleError(ExchangeServiceException e) throws MessagingException
	{
		throw new MessagingException(e.toString(), e);
	}
	
	public Session getSession()
	{
		return session;
	}
}
